﻿using SKBKontur.KZ.Core;

namespace SKBKontur.KZ.User
{
    public partial class UserClass
    {
        private IReferences Refs
        {
            get { return KzApp.GetService<IReferences>(); }
        }

        public bool Department_Create(int code, string name)
        {
            return new DepartmentList(Refs).Create(code, name);
        }
        public bool Department_Exists(int code)
        {
            return new DepartmentList(Refs).Exists(code);
        }

        public string Department_GetName(int code)
        {
            return new DepartmentList(Refs).GetName(code);
        }
        public void Department_SetName(int code, string name)
        {
            new DepartmentList(Refs).SetName(code,name);
        }
        public void Department_SetExternCode(int code, string extCode)
        {
            new DepartmentList(Refs).SetExternCode(code, extCode);
        }
    }
    class DepartmentList
    {
        private readonly IReferences _refs;
        public DepartmentList(IReferences refs)
        {
            _refs = refs;
        }
        public bool Create(int code, string name)
        {
            if (Exists(code))
                return false;

            using (var editor = _refs.Departments.TryGetEditor())
            {
                if (editor.Status != LockStatus.Acquired)
                {
                    //todo: кикать расчетчика
                    // MsgBox("Занято!...
                    return false;
                }
                editor.AddNew(code);
                editor[code].Name = name;
                editor.Save();
            }
            return true;
        }
        public bool Exists(int code)
        {
            return _refs.Departments.ContainsKey(code);
        }
        public string GetName(int code)
        {
            if (!Exists(code)) return "";

            var listDep = _refs.Departments;
            return listDep[code].Name;
        }
        public void SetName(int code, string name)
        {
            if (!Exists(code)) return;

            using (var editor = _refs.Departments.TryGetEditor())
            {
                if (editor.Status != LockStatus.Acquired)
                {
                    //todo: кикать расчетчика
                    // MsgBox("Занято!...
                    return;
                }
                editor[code].Name = name;
                editor.Save();
            }
        }
        public void SetExternCode(int code, string extCode)
        {
            if (!Exists(code)) return;

            using (var editor = _refs.Departments.TryGetEditor())
            {
                if (editor.Status != LockStatus.Acquired)
                {
                    //todo: кикать расчетчика
                    // MsgBox("Занято!...
                    return;
                }
                editor[code].ExtKod = extCode;
                editor.Save();
            }
        }
    }
}
