﻿using System;
using System.Collections.Generic;
using System.Linq;
using SKBKontur.KZ.Core;

namespace SKBKontur.KZ.User.Helpers
{
    public static class RowNuListHelper
    {
        /// <summary>
        /// строки действуют в mtek
        /// </summary>
        /// <param name="rows"></param>
        /// <param name="month"></param>
        /// <returns></returns>
        public static IEnumerable<IRowNU> ValidIn(this IRowNUList rows, int month)
        {
            return rows.Where(r => r.DateEnd.IsValid() && //отбрасываем пересчетные строки
                                   r.DateEnd.ToAbsMonth() >= month && //заканчивается в month или в сл. месяце
                                   (!r.DateBeg.IsValid() ||
                                    r.DateBeg.ToAbsMonth() <= month)); //дата начала не указана или дата начала<= month
        }
        public static IEnumerable<IRowNU> ValidOn(this IRowNUList rows, DateTime date)
        {
            return rows.Where(r => r.DateEnd.IsValid() && //отбрасываем пересчетные строки
                                   r.DateEnd>=date && 
                                   (!r.DateBeg.IsValid() ||
                                    r.DateBeg <= date)); //дата начала не указана или дата начала<= month
        }
        public static IEnumerable<IRowNU> FiltrCombine(this IEnumerable<IRowNU> rows, int combine)
        {
            return rows.Where(r => r.IspDoljn == combine);
        }

        
    }
}
