﻿using System.Collections;
using SKBKontur.KZ.Core;
using XMachineLib;

namespace SKBKontur.KZ.User.Helpers
{

    public class ScriptHelper
    {
        private static Hashtable _scriptTable;
        private static IXMachine XMachine { get; set; }

        public ScriptHelper(IScriptService scriptService)
        {
            _scriptTable = new Hashtable();
            XMachine = scriptService.GetXMachine();
        }

        private object CreateBlock(string source)
        {
            if (!_scriptTable.ContainsKey(source))
                _scriptTable.Add(source, XMachine.CreateBlock(source));
            return _scriptTable[source];
        }

        public T Evaluate<T>(object code, params object[] args)
        {
            var o = XMachine.Evaluate(CreateBlock((string) code), args);
            return (T) o;
        }

        public T Call<T>(string code, params object[] args)
        {
            var o = XMachine.Call(code, args);
            return (T) o;
        }

    }

}