﻿using System.Collections.Generic;
using SKBKontur.KZ.Core.Reporting;

namespace SKBKontur.KZ.User.Print.FotByIstCat
{
    public class ReportManager
    {
        private readonly ManagersCommon _managersCommon;
        private List<PersonData> _reportData;
        public ReportManager(ManagersCommon managersCommon)
        {
            _managersCommon = managersCommon;
        }
        
        public void FillData()
        {
            _reportData=new List<PersonData>();
            DataGetter.CollectData(_reportData);
        }

        public void Print()
        {
            using (var workbook = _managersCommon.OfficeService.CreateWorkbook())
            {
                try
                {
                    ExcelHelper.PrintData(workbook, _reportData);
                }
                finally
                {
                    workbook.Visible = true;
                    workbook.Detach();
                }
            }

        }
    }
}
