using System;
using System.Data.SqlClient;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;
using NLog;
using SKBKontur.KZ.Common;
using SKBKontur.KZ.Core;
using usefulLib;
// ReSharper disable UnusedMember.Global

namespace SKBKontur.KZ.User
{
   [ComVisible(true)]
   [ClassInterface(ClassInterfaceType.AutoDispatch)]
   [Guid("4E4846B3-57C4-4a31-8E51-F11122ED600D")]
   public partial class UserClass
   {
       private Logger Logger= LogManager.GetLogger("KZ.USER.Logger");
       public IKZ KzApp { get; }
       public UserClass(IKZ kz)
       {
         KzApp = kz;
       }
      public string GetOrgInn()
      {
         var eList = KzApp.GetService<IEnterpriseList>();
         return eList[eList.BaseId].Var("").Trim();
      }

      public int TestNetUser(string message)
      {
         TestForm form = new TestForm(message);
         form.ShowDialog();
         return 1;
      }

      public void TestTable(object table)
      {
      //    ,     
      //  var table=CreateObject("CurPrnTbl");
		//  NetUserClasses().TestTable(table);

         IPrnTable prnTable = (IPrnTable) table;
         MessageBox.Show(DosToWin(prnTable.TextS("FIO", 0)));
         //prnTable.STextS("FIO",0,DOS(""));   
      }

      public static string DosToWin(string dosStr)
      {
         byte[] bytesIn = Encoding.GetEncoding(1251).GetBytes(dosStr);
         byte[] bytesOut = Encoding.Convert(Encoding.GetEncoding(866), Encoding.GetEncoding(1251), bytesIn);
         return Encoding.GetEncoding(1251).GetString(bytesOut);
      }

      /// <summary>
      ///    DOS-
      /// </summary>
      public static string DOS(string str)
      {
         byte[] bytesIn = Encoding.GetEncoding(1251).GetBytes(str);
         byte[] bytesOut = Encoding.Convert(Encoding.GetEncoding(1251), Encoding.GetEncoding(866), bytesIn);
         return Encoding.GetEncoding(1251).GetString(bytesOut);
      }

       public string GetAmbaKeyFromKPOrder(string entId)
       {
           try
           {
               return GetAmbaKeyFromKPOrder_Impl(entId);
           }
           catch (Exception e)
           {
               return "";
           }
           
       }

       private string GetAmbaKeyFromKPOrder_Impl(string entId)
       {
           var queryString = $"SELECT AmbaKey FROM [dbo].[KPOrder] WHERE EntId = @EntId"; 
           var connectionString = System.Configuration.ConfigurationManager.ConnectionStrings["KzDb"].ConnectionString;
           using (var connection = new SqlConnection(connectionString))
           {
               var command = new SqlCommand(queryString, connection);
               command.Parameters.AddWithValue("@EntId", entId.ToInt());
               connection.Open();
               var reader = command.ExecuteReader();
               try
               {
                   reader.Read();
                   return reader["AmbaKey"].ToString();
               }
               finally
               {
                   reader.Close();
               }
           }
        }
   }
}