﻿
using System.Collections.Generic;
using System.Linq;
using SKBKontur.KZ.Common;
using SKBKontur.KZ.Core;


using SKBKontur.KZ.User.CompareSumms.AvansCompare;
using SKBKontur.KZ.User.LsData;

namespace SKBKontur.KZ.User
{
    public partial class UserClass
    {
        public void SummCompare(string fileName,string nuName_1c,int KzNuCode)
        {
            var data_1C = GetSummData(fileName).Cast<SummInfo>().ToList().Where(p=>p.NuName.Contains(nuName_1c)).ToList().CastToSummAvansInfo();
            var dataKz = CompareSumms.AvansCompare.DataHelper.GetKzData(KzNuCode,KzApp);
            CompareSumms.AvansCompare.PrintHelper.PrintDifference(data_1C, dataKz, KzApp.GetService<IOptions>());
        }
        public void PlanNuCompare(string fileName,string nuListForCompare)
        {
            var listNu = nuListForCompare.Split(',').Select(nuCode => nuCode.ToInt()).ToList();
            var data_1C = CompareSumms.PlanNuCompare.DataHelper.GetPlanSumm(fileName, KzApp).Where(p=>listNu.Contains(p.NuCode)).ToList();
            CompareSumms.PlanNuCompare.DataHelper.GroupData(ref data_1C);
            CompareSumms.PlanNuCompare.DataHelper.CalcBz(data_1C);


            CompareSumms.PlanNuCompare.DataHelper.FillRefs(KzApp,out Dictionary<int, string> dolgnNameDic,out Dictionary<int,int> tnDic,out Dictionary<int,double> stavkaDic);

            var dataKz = CompareSumms.PlanNuCompare.DataHelper.GetKzPlanSumm(KzApp).Where(p => listNu.Contains(p.NuCode)).ToList();
            CompareSumms.PlanNuCompare.DataHelper.GroupData(ref dataKz);
            CompareSumms.PlanNuCompare.PrintHelper.PrintDifference(data_1C, dataKz, KzApp.GetService<IOptions>(), dolgnNameDic, tnDic, stavkaDic);
        }

        public void AllSummCompare(string fileName, string nuListForCompare, string excludeDolgnCode,int printByPodr)
        {
            /* var compareNuList=new List<int>()
           {
                897,
                123,
                21,
                178,
                124,
                127,
                131,
                136,
                137,
                196
            };     var compareNuList = new List<int>()
            {
                178,
                196
            };*/

            var compareNuList = nuListForCompare.Split(',').Select(nuCode => nuCode.ToInt()).ToList();
            //должности, которые нужно убрать из сравнения
            var excludeDolgnCodeList= excludeDolgnCode.Split(',').Select(dolgnCode => dolgnCode.ToInt()).ToList();
            //берем только то, что сравниваем и не учитываем пересчеты за другие месяцы
            var data_1C = GetSummData(fileName)?.Cast<SummInfo>().Select(p=>(CompareSumms.AllSummCompare.SummInfo)p).Where(p => compareNuList.Contains(p.NuCodeForCompare) && p.MNach==p.MPrin && !excludeDolgnCodeList.Contains(p.DolgCode)).ToList();
            //вычисляем ТН и код подразделения и combine
            var script = new Helpers.ScriptHelper(KzApp.GetService<IScriptService>());
            foreach (var summInfo in data_1C)
                script.Call<object>("FillAdditionalData", summInfo);
            //группируем по ключу
            CompareSumms.AllSummCompare.DataHelper.GroupData(ref data_1C);
            CompareSumms.AllSummCompare.DataHelper.CalcBz(data_1C);
            
            var data_Kz = CompareSumms.AllSummCompare.DataHelper.GetData(true,KzApp).Where(p => compareNuList.Contains(p.NuCodeForCompare) && p.MNach == p.MPrin).ToList();
            CompareSumms.AllSummCompare.DataHelper.GroupData(ref data_Kz);
       
            CompareSumms.AllSummCompare.DataHelper.FillRefs(KzApp, out Dictionary<int, string> dolgnNameDic, out Dictionary<int, int> tnDic);
            //печатаем один отчет на всех/или с разбивкой по подразделениям
            CompareSumms.AllSummCompare.PrintHelper.PrintDifferenceWithSrc(data_1C.ToList(), data_Kz.ToList(),KzApp.GetService<IOptions>(), KzApp.GetService<IReferences>(), dolgnNameDic, printByPodr != 0, true);
        }
    }
}

