﻿using System.Linq;
using SKBKontur.KZ.Core;
using SKBKontur.KZ.Core.Reporting;
using SKBKontur.KZ.Forms;
using SKBKontur.KZ.OfficeInterop;
using SKBKontur.KZ.User.Print.FotByIstCat;
using IUserInteraction = SKBKontur.KZ.Core.IUserInteraction;

namespace SKBKontur.KZ.User
{
    public partial class UserClass
    {
        public void PrintFotByIstCat()
        {
            if (!KzApp.GetService<ILsList>().WithReadAccess().Any(p => p.GlobalSelected))
            {
                MsgBox.ShowInfo("Не выбраны ЛС для отчета");
                return;
            }

            var managers= new ManagersCommon(
                options: KzApp.GetService<IOptions>(),
                references: KzApp.GetService<IReferences>(),
                enterpriseList: KzApp.GetService<IEnterpriseList>(),
                lsList: KzApp.GetService<ILsList>(),
                xMachine: KzApp.GetService<IScriptService>().GetXMachine(),
                kTableMgr: KzApp.GetService<IKTableManager>(),
                userInteraction: KzApp.GetService<IUserInteraction>(),
                officeService: new OfficeService() { PreferredOffice = KzApp.GetService<IOptions>().PreferredOffice() },
                scriptService: KzApp.GetService<IScriptService>());

            var reportManager = new ReportManager(managers);
            reportManager.FillData();
            reportManager.Print();
        }
    }
}
